--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
@@ -1162,21 +1202,17 @@
 	}
 	ADAPTER_STATE_UNLOCK(ha);
 
-	ha->execution_throttle = CHAR_TO_SHORT(nv->execution_throttle[0],
-	    nv->execution_throttle[1]);
-	ha->loop_reset_delay = nv->reset_delay;
-	ha->port_down_retry_count = CHAR_TO_SHORT(nv->port_down_retry_count[0],
-	    nv->port_down_retry_count[1]);
-	w1 = CHAR_TO_SHORT(icb->login_timeout[0], icb->login_timeout[1]);
-	ha->r_a_tov = (uint16_t)(w1 < R_A_TOV_DEFAULT ? R_A_TOV_DEFAULT : w1);
-	ha->maximum_luns_per_target = CHAR_TO_SHORT(
-	    nv->max_luns_per_target[0], nv->max_luns_per_target[1]);
-	if (ha->maximum_luns_per_target == 0) {
-		ha->maximum_luns_per_target++;
+	/* Queue shadowing */
+	if (ha->flags & QUEUE_SHADOW_PTRS) {
+		icb->firmware_options_2[3] = (uint8_t)
+		    (icb->firmware_options_2[3] | BIT_6 | BIT_5);
+	} else {
+		icb->firmware_options_2[3] = (uint8_t)
+		    (icb->firmware_options_2[3] | ~(BIT_6 | BIT_5));
 	}
 
 	/* ISP2422 Serial Link Control */
-	if (CFG_IST(ha, CFG_CTRL_2422)) {
+	if (CFG_IST(ha, CFG_CTRL_24XX)) {
 		ha->serdes_param[0] = CHAR_TO_SHORT(nv->fw.isp2400.swing_opt[0],
 		    nv->fw.isp2400.swing_opt[1]);
 		ha->serdes_param[1] = CHAR_TO_SHORT(nv->fw.isp2400.swing_1g[0],
@@ -1187,34 +1223,56 @@
 		    nv->fw.isp2400.swing_4g[1]);
 	}
 
+	els->common_service.rx_bufsize = CHAR_TO_SHORT(
+	    icb->max_frame_length[0], icb->max_frame_length[1]);
+	bcopy((void *)icb->port_name, (void *)els->nport_ww_name.raw_wwn, 8);
+	bcopy((void *)icb->node_name, (void *)els->node_ww_name.raw_wwn, 8);
+
+	cmn_err(CE_CONT, "!Qlogic %s(%d) WWPN=%02x%02x%02x%02x"
+	    "%02x%02x%02x%02x : WWNN=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+	    QL_NAME, ha->instance,
+	    els->nport_ww_name.raw_wwn[0], els->nport_ww_name.raw_wwn[1],
+	    els->nport_ww_name.raw_wwn[2], els->nport_ww_name.raw_wwn[3],
+	    els->nport_ww_name.raw_wwn[4], els->nport_ww_name.raw_wwn[5],
+	    els->nport_ww_name.raw_wwn[6], els->nport_ww_name.raw_wwn[7],
+	    els->node_ww_name.raw_wwn[0], els->node_ww_name.raw_wwn[1],
+	    els->node_ww_name.raw_wwn[2], els->node_ww_name.raw_wwn[3],
+	    els->node_ww_name.raw_wwn[4], els->node_ww_name.raw_wwn[5],
+	    els->node_ww_name.raw_wwn[6], els->node_ww_name.raw_wwn[7]);
 	/*
 	 * Setup ring parameters in initialization control block
 	 */
-	w1 = REQUEST_ENTRY_CNT;
+	w1 = ha->req_q[0]->req_entry_cnt;
 	icb->request_q_length[0] = LSB(w1);
 	icb->request_q_length[1] = MSB(w1);
-	w1 = RESPONSE_ENTRY_CNT;
+	w1 = ha->rsp_queues[0]->rsp_entry_cnt;
 	icb->response_q_length[0] = LSB(w1);
 	icb->response_q_length[1] = MSB(w1);
 
-	icb->request_q_address[0] = LSB(LSW(LSD(ha->request_dvma)));
-	icb->request_q_address[1] = MSB(LSW(LSD(ha->request_dvma)));
-	icb->request_q_address[2] = LSB(MSW(LSD(ha->request_dvma)));
-	icb->request_q_address[3] = MSB(MSW(LSD(ha->request_dvma)));
-	icb->request_q_address[4] = LSB(LSW(MSD(ha->request_dvma)));
-	icb->request_q_address[5] = MSB(LSW(MSD(ha->request_dvma)));
-	icb->request_q_address[6] = LSB(MSW(MSD(ha->request_dvma)));
-	icb->request_q_address[7] = MSB(MSW(MSD(ha->request_dvma)));
+	addr = ha->req_q[0]->req_ring.cookie.dmac_address;
+	icb->request_q_address[0] = LSB(LSW(addr));
+	icb->request_q_address[1] = MSB(LSW(addr));
+	icb->request_q_address[2] = LSB(MSW(addr));
+	icb->request_q_address[3] = MSB(MSW(addr));
 
-	icb->response_q_address[0] = LSB(LSW(LSD(ha->response_dvma)));
-	icb->response_q_address[1] = MSB(LSW(LSD(ha->response_dvma)));
-	icb->response_q_address[2] = LSB(MSW(LSD(ha->response_dvma)));
-	icb->response_q_address[3] = MSB(MSW(LSD(ha->response_dvma)));
-	icb->response_q_address[4] = LSB(LSW(MSD(ha->response_dvma)));
-	icb->response_q_address[5] = MSB(LSW(MSD(ha->response_dvma)));
-	icb->response_q_address[6] = LSB(MSW(MSD(ha->response_dvma)));
-	icb->response_q_address[7] = MSB(MSW(MSD(ha->response_dvma)));
+	addr = ha->req_q[0]->req_ring.cookie.dmac_notused;
+	icb->request_q_address[4] = LSB(LSW(addr));
+	icb->request_q_address[5] = MSB(LSW(addr));
+	icb->request_q_address[6] = LSB(MSW(addr));
+	icb->request_q_address[7] = MSB(MSW(addr));
 
+	addr = ha->rsp_queues[0]->rsp_ring.cookie.dmac_address;
+	icb->response_q_address[0] = LSB(LSW(addr));
+	icb->response_q_address[1] = MSB(LSW(addr));
+	icb->response_q_address[2] = LSB(MSW(addr));
+	icb->response_q_address[3] = MSB(MSW(addr));
+
+	addr = ha->rsp_queues[0]->rsp_ring.cookie.dmac_notused;
+	icb->response_q_address[4] = LSB(LSW(addr));
+	icb->response_q_address[5] = MSB(LSW(addr));
+	icb->response_q_address[6] = LSB(MSW(addr));
+	icb->response_q_address[7] = MSB(MSW(addr));
+
 	/*
 	 * Setup IP initialization control block
 	 */
@@ -1227,7 +1285,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -1254,6 +1312,8 @@
 {
 	int	i;
 
+	QL_PRINT_3(ha, "started\n");
+
 	if ((flags & LNF_NVRAM_DATA) && (flags & LNF_VPD_DATA)) {
 		EL(ha, "invalid options for function");
 		return (QL_FUNCTION_FAILED);
@@ -1285,7 +1345,7 @@
 			    QL_NAME, ha->instance);
 			return (QL_FUNCTION_FAILED);
 		}
-	} else if (CFG_IST(ha, CFG_CTRL_2422)) {
+	} else if (CFG_IST(ha, CFG_CTRL_24XX)) {
 		if (flags & LNF_VPD_DATA) {
 			*addr = NVRAM_DATA_ADDR | ha->flash_vpd_addr;
 		} else if (flags & LNF_NVRAM_DATA) {
@@ -1296,7 +1356,7 @@
 		}
 
 		GLOBAL_HW_LOCK();
-	} else if (CFG_IST(ha, CFG_CTRL_258081)) {
+	} else if (CFG_IST(ha, CFG_CTRL_252780818283)) {
 		if (flags & LNF_VPD_DATA) {
 			*addr = ha->flash_data_addr | ha->flash_vpd_addr;
 		} else if (flags & LNF_NVRAM_DATA) {
@@ -1316,6 +1376,8 @@
 		GLOBAL_HW_LOCK();
 	}
 
+	QL_PRINT_3(ha, "done\n");
+
 	return (QL_SUCCESS);
 }
 
@@ -1332,6 +1394,8 @@
 void
 ql_release_nvram(ql_adapter_state_t *ha)
 {
+	QL_PRINT_3(ha, "started\n");
+
 	if (ha->device_id == 0x2312 || ha->device_id == 0x2322) {
 		/* Release resource lock */
 		WRT16_IO_REG(ha, host_to_host_sema, 0);
@@ -1338,6 +1402,8 @@
 	} else {
 		GLOBAL_HW_UNLOCK();
 	}
+
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -1350,17 +1416,17 @@
  *
  * Input:
  *	ha:	adapter state pointer.
- *	nv:	NVRAM structure pointer.
+ *	icb:	Init control block structure pointer.
  *
  * Context:
  *	Kernel context.
  */
 static void
-ql_23_properties(ql_adapter_state_t *ha, nvram_t *nv)
+ql_23_properties(ql_adapter_state_t *ha, ql_init_cb_t *icb)
 {
 	uint32_t	data, cnt;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Get frame payload size. */
 	if ((data = ql_get_prop(ha, "max-frame-length")) == 0xffffffff) {
@@ -1367,17 +1433,17 @@
 		data = 2048;
 	}
 	if (data == 512 || data == 1024 || data == 2048) {
-		nv->max_frame_length[0] = LSB(data);
-		nv->max_frame_length[1] = MSB(data);
+		icb->max_frame_length[0] = LSB(data);
+		icb->max_frame_length[1] = MSB(data);
 	} else {
 		EL(ha, "invalid parameter value for 'max-frame-length': "
 		    "%d; using nvram default of %d\n", data, CHAR_TO_SHORT(
-		    nv->max_frame_length[0], nv->max_frame_length[1]));
+		    icb->max_frame_length[0], icb->max_frame_length[1]));
 	}
 
 	/* Get max IOCB allocation. */
-	nv->max_iocb_allocation[0] = 0;
-	nv->max_iocb_allocation[1] = 1;
+	icb->max_iocb_allocation[0] = 0;
+	icb->max_iocb_allocation[1] = 1;
 
 	/* Get execution throttle. */
 	if ((data = ql_get_prop(ha, "execution-throttle")) == 0xffffffff) {
@@ -1384,12 +1450,12 @@
 		data = 32;
 	}
 	if (data != 0 && data < 65536) {
-		nv->execution_throttle[0] = LSB(data);
-		nv->execution_throttle[1] = MSB(data);
+		icb->execution_throttle[0] = LSB(data);
+		icb->execution_throttle[1] = MSB(data);
 	} else {
 		EL(ha, "invalid parameter value for 'execution-throttle': "
 		    "%d; using nvram default of %d\n", data, CHAR_TO_SHORT(
-		    nv->execution_throttle[0], nv->execution_throttle[1]));
+		    icb->execution_throttle[0], icb->execution_throttle[1]));
 	}
 
 	/* Get Login timeout. */
@@ -1397,10 +1463,10 @@
 		data = 3;
 	}
 	if (data < 256) {
-		nv->login_timeout = (uint8_t)data;
+		icb->login_timeout = (uint8_t)data;
 	} else {
 		EL(ha, "invalid parameter value for 'login-timeout': "
-		    "%d; using nvram value of %d\n", data, nv->login_timeout);
+		    "%d; using nvram value of %d\n", data, icb->login_timeout);
 	}
 
 	/* Get retry count. */
@@ -1408,35 +1474,35 @@
 		data = 4;
 	}
 	if (data < 256) {
-		nv->login_retry_count = (uint8_t)data;
+		icb->login_retry_count = (uint8_t)data;
 	} else {
 		EL(ha, "invalid parameter value for 'login-retry-count': "
 		    "%d; using nvram value of %d\n", data,
-		    nv->login_retry_count);
+		    icb->login_retry_count);
 	}
 
 	/* Get adapter hard loop ID enable. */
-	data =  ql_get_prop(ha, "enable-adapter-hard-loop-ID");
+	data = ql_get_prop(ha, "enable-adapter-hard-loop-ID");
 	if (data == 0) {
-		nv->firmware_options[0] =
-		    (uint8_t)(nv->firmware_options[0] & ~BIT_0);
+		icb->firmware_options[0] =
+		    (uint8_t)(icb->firmware_options[0] & ~BIT_0);
 	} else if (data == 1) {
-		nv->firmware_options[0] =
-		    (uint8_t)(nv->firmware_options[0] | BIT_0);
+		icb->firmware_options[0] =
+		    (uint8_t)(icb->firmware_options[0] | BIT_0);
 	} else if (data != 0xffffffff) {
 		EL(ha, "invalid parameter value for "
 		    "'enable-adapter-hard-loop-ID': %d; using nvram value "
-		    "of %d\n", data, nv->firmware_options[0] & BIT_0 ? 1 : 0);
+		    "of %d\n", data, icb->firmware_options[0] & BIT_0 ? 1 : 0);
 	}
 
 	/* Get adapter hard loop ID. */
-	data =  ql_get_prop(ha, "adapter-hard-loop-ID");
+	data = ql_get_prop(ha, "adapter-hard-loop-ID");
 	if (data < 126) {
-		nv->hard_address[0] = (uint8_t)data;
+		icb->hard_address[0] = (uint8_t)data;
 	} else if (data != 0xffffffff) {
 		EL(ha, "invalid parameter value for 'adapter-hard-loop-ID': "
 		    "%d; using nvram value of %d\n",
-		    data, nv->hard_address[0]);
+		    data, icb->hard_address[0]);
 	}
 
 	/* Get LIP reset. */
@@ -1445,13 +1511,14 @@
 		data = 0;
 	}
 	if (data == 0) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] & ~BIT_1);
+		ha->cfg_flags &= ~CFG_ENABLE_LIP_RESET;
 	} else if (data == 1) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] | BIT_1);
+		ha->cfg_flags |= CFG_ENABLE_LIP_RESET;
 	} else {
 		EL(ha, "invalid parameter value for "
 		    "'enable-LIP-reset-on-bus-reset': %d; using nvram value "
-		    "of %d\n", data, nv->host_p[1] & BIT_1 ? 1 : 0);
+		    "of %d\n", data,
+		    CFG_IST(ha, CFG_ENABLE_LIP_RESET) ? 1 : 0);
 	}
 
 	/* Get LIP full login. */
@@ -1460,13 +1527,14 @@
 		data = 1;
 	}
 	if (data == 0) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] & ~BIT_2);
+		ha->cfg_flags &= ~CFG_ENABLE_FULL_LIP_LOGIN;
 	} else if (data == 1) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] | BIT_2);
+		ha->cfg_flags |= CFG_ENABLE_FULL_LIP_LOGIN;
 	} else {
 		EL(ha, "invalid parameter value for "
 		    "'enable-LIP-full-login-on-bus-reset': %d; using nvram "
-		    "value of %d\n", data, nv->host_p[1] & BIT_2 ? 1 : 0);
+		    "value of %d\n", data,
+		    CFG_IST(ha, CFG_ENABLE_FULL_LIP_LOGIN) ? 1 : 0);
 	}
 
 	/* Get target reset. */
@@ -1475,13 +1543,14 @@
 		data = 0;
 	}
 	if (data == 0) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] & ~BIT_3);
+		ha->cfg_flags &= ~CFG_ENABLE_TARGET_RESET;
 	} else if (data == 1) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] | BIT_3);
+		ha->cfg_flags |= CFG_ENABLE_TARGET_RESET;
 	} else {
 		EL(ha, "invalid parameter value for "
 		    "'enable-target-reset-on-bus-reset': %d; using nvram "
-		    "value of %d", data, nv->host_p[1] & BIT_3 ? 1 : 0);
+		    "value of %d", data,
+		    CFG_IST(ha, CFG_ENABLE_TARGET_RESET) ? 1 : 0);
 	}
 
 	/* Get reset delay. */
@@ -1489,10 +1558,10 @@
 		data = 5;
 	}
 	if (data != 0 && data < 256) {
-		nv->reset_delay = (uint8_t)data;
+		ha->loop_reset_delay = (uint8_t)data;
 	} else {
 		EL(ha, "invalid parameter value for 'reset-delay': %d; "
-		    "using nvram value of %d", data, nv->reset_delay);
+		    "using nvram value of %d", data, ha->loop_reset_delay);
 	}
 
 	/* Get port down retry count. */
@@ -1500,11 +1569,11 @@
 		data = 8;
 	}
 	if (data < 256) {
-		nv->port_down_retry_count = (uint8_t)data;
+		ha->port_down_retry_count = (uint8_t)data;
 	} else {
 		EL(ha, "invalid parameter value for 'port-down-retry-count':"
 		    " %d; using nvram value of %d\n", data,
-		    nv->port_down_retry_count);
+		    ha->port_down_retry_count);
 	}
 
 	/* Get connection mode setting. */
@@ -1511,41 +1580,35 @@
 	if ((data = ql_get_prop(ha, "connection-options")) == 0xffffffff) {
 		data = 2;
 	}
-	cnt = CFG_IST(ha, CFG_CTRL_2200) ? 3 : 2;
+	cnt = CFG_IST(ha, CFG_CTRL_22XX) ? 3 : 2;
 	if (data <= cnt) {
-		nv->add_fw_opt[0] = (uint8_t)(nv->add_fw_opt[0] &
+		icb->add_fw_opt[0] = (uint8_t)(icb->add_fw_opt[0] &
 		    ~(BIT_6 | BIT_5 | BIT_4));
-		nv->add_fw_opt[0] = (uint8_t)(nv->add_fw_opt[0] |
+		icb->add_fw_opt[0] = (uint8_t)(icb->add_fw_opt[0] |
 		    (uint8_t)(data << 4));
 	} else {
 		EL(ha, "invalid parameter value for 'connection-options': "
 		    "%d; using nvram value of %d\n", data,
-		    (nv->add_fw_opt[0] >> 4) & 0x3);
+		    (icb->add_fw_opt[0] >> 4) & 0x3);
 	}
 
 	/* Get data rate setting. */
-	if ((CFG_IST(ha, CFG_CTRL_2200)) == 0) {
+	if ((CFG_IST(ha, CFG_CTRL_22XX)) == 0) {
 		if ((data = ql_get_prop(ha, "fc-data-rate")) == 0xffffffff) {
 			data = 2;
 		}
 		if (data < 3) {
-			nv->special_options[1] = (uint8_t)
-			    (nv->special_options[1] & 0x3f);
-			nv->special_options[1] = (uint8_t)
-			    (nv->special_options[1] | (uint8_t)(data << 6));
+			icb->special_options[1] = (uint8_t)
+			    (icb->special_options[1] & 0x3f);
+			icb->special_options[1] = (uint8_t)
+			    (icb->special_options[1] | (uint8_t)(data << 6));
 		} else {
 			EL(ha, "invalid parameter value for 'fc-data-rate': "
 			    "%d; using nvram value of %d\n", data,
-			    (nv->special_options[1] >> 6) & 0x3);
+			    (icb->special_options[1] >> 6) & 0x3);
 		}
 	}
 
-	/* Get adapter id string for Sun branded 23xx only */
-	if ((CFG_IST(ha, CFG_CTRL_2300)) && nv->adapInfo[0] != 0) {
-		(void) snprintf((int8_t *)ha->adapInfo, 16, "%s",
-		    nv->adapInfo);
-	}
-
 	/* Get IP FW container count. */
 	ha->ip_init_ctrl_blk.cb.cc[0] = LSB(ql_ip_buffer_count);
 	ha->ip_init_ctrl_blk.cb.cc[1] = MSB(ql_ip_buffer_count);
@@ -1564,7 +1627,7 @@
 
 	ADAPTER_STATE_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -1586,34 +1649,8 @@
 {
 	uint32_t	data;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
-	/* Get extended logging trace buffer size. */
-	if ((data = ql_get_prop(ha, "set-ext-log-buffer-size")) !=
-	    0xffffffff && data != 0) {
-		char		*new_trace;
-		uint32_t	new_size;
-
-		if (ha->el_trace_desc->trace_buffer != NULL) {
-			new_size = 1024 * data;
-			new_trace = (char *)kmem_zalloc(new_size, KM_SLEEP);
-
-			if (new_trace == NULL) {
-				cmn_err(CE_WARN, "%s(%d): can't get new"
-				    " trace buffer",
-				    QL_NAME, ha->instance);
-			} else {
-				/* free the previous */
-				kmem_free(ha->el_trace_desc->trace_buffer,
-				    ha->el_trace_desc->trace_buffer_size);
-				/* Use the new one */
-				ha->el_trace_desc->trace_buffer = new_trace;
-				ha->el_trace_desc->trace_buffer_size = new_size;
-			}
-		}
-
-	}
-
 	/* Get extended logging enable. */
 	if ((data = ql_get_prop(ha, "extended-logging")) == 0xffffffff ||
 	    data == 0) {
@@ -1626,19 +1663,6 @@
 		ha->cfg_flags &= ~CFG_ENABLE_EXTENDED_LOGGING;
 	}
 
-	/* Get extended logging trace disable. */
-	if ((data = ql_get_prop(ha, "disable-extended-logging-trace")) ==
-	    0xffffffff || data == 0) {
-		ha->cfg_flags &= ~CFG_DISABLE_EXTENDED_LOGGING_TRACE;
-	} else if (data == 1) {
-		ha->cfg_flags |= CFG_DISABLE_EXTENDED_LOGGING_TRACE;
-	} else {
-		EL(ha, "invalid parameter value for "
-		    "'disable-extended-logging-trace': %d;"
-		    " using default value of 0\n", data);
-		ha->cfg_flags &= ~CFG_DISABLE_EXTENDED_LOGGING_TRACE;
-	}
-
 	/* Get FCP 2 Error Recovery. */
 	if ((data = ql_get_prop(ha, "enable-FCP-2-error-recovery")) ==
 	    0xffffffff || data == 1) {
@@ -1747,11 +1771,21 @@
 		ha->pci_max_read_req = (uint16_t)(data);
 	}
 
+	/* Get the plogi retry params overrides. */
+	if ((data = ql_get_prop(ha, "plogi_params_retry_count")) !=
+	    0xffffffff && data != 0) {
+		ha->plogi_params->retry_cnt = (uint32_t)(data);
+	}
+	if ((data = ql_get_prop(ha, "plogi_params_retry_delay")) !=
+	    0xffffffff && data != 0) {
+		ha->plogi_params->retry_dly_usec = (uint32_t)(data);
+	}
+
 	/*
 	 * Set default fw wait, adjusted for slow FCF's.
 	 * Revisit when FCF's as fast as FC switches.
 	 */
-	ha->fwwait = (uint8_t)(CFG_IST(ha, CFG_CTRL_8081) ? 45 : 10);
+	ha->fwwait = (uint8_t)(CFG_IST(ha, CFG_FCOE_SUPPORT) ? 45 : 10);
 	/* Get the attach fw_ready override value. */
 	if ((data = ql_get_prop(ha, "init-loop-sync-wait")) != 0xffffffff) {
 		if (data > 0 && data <= 240) {
@@ -1763,7 +1797,44 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	/* Get fm-capable property */
+	ha->fm_capabilities = DDI_FM_NOT_CAPABLE;
+	if ((data = ql_get_prop(ha, "fm-capable")) != 0xffffffff) {
+		if (data == 0) {
+			ha->fm_capabilities = DDI_FM_NOT_CAPABLE;
+		} else if (data > 0xf) {
+			ha->fm_capabilities = 0xf;
+
+		} else {
+			ha->fm_capabilities = (int)(data);
+		}
+	} else {
+		ha->fm_capabilities = (int)(DDI_FM_EREPORT_CAPABLE
+		    | DDI_FM_ERRCB_CAPABLE);
+	}
+
+	if ((data = ql_get_prop(ha, "msix-vectors")) == 0xffffffff) {
+		ha->mq_msix_vectors = 0;
+	} else if (data < 256) {
+		ha->mq_msix_vectors = (uint8_t)data;
+	} else {
+		EL(ha, "invalid parameter value for 'msix-vectors': "
+		    "%d; using value of %d\n", data, 0);
+		ha->mq_msix_vectors = 0;
+	}
+
+	/* Get number of completion threads. */
+	if ((data = ql_get_prop(ha, "completion-threads")) == 0xffffffff) {
+		ha->completion_thds = 4;
+	} else if (data < 256 && data >= 1) {
+		ha->completion_thds = (uint8_t)data;
+	} else {
+		EL(ha, "invalid parameter value for 'completion-threads':"
+		    " %d; using default value of %d", data, 4);
+		ha->completion_thds = 4;
+	}
+
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -1776,17 +1847,17 @@
  *
  * Input:
  *	ha:	adapter state pointer.
- *	nv:	NVRAM structure pointer.
+ *	icb:	Init control block structure pointer.
  *
  * Context:
  *	Kernel context.
  */
 static void
-ql_24xx_properties(ql_adapter_state_t *ha, nvram_24xx_t *nv)
+ql_24xx_properties(ql_adapter_state_t *ha, ql_init_24xx_cb_t *icb)
 {
 	uint32_t	data;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Get frame size */
 	if ((data = ql_get_prop(ha, "max-frame-length")) == 0xffffffff) {
@@ -1793,12 +1864,12 @@
 		data = 2048;
 	}
 	if (data == 512 || data == 1024 || data == 2048 || data == 2112) {
-		nv->max_frame_length[0] = LSB(data);
-		nv->max_frame_length[1] = MSB(data);
+		icb->max_frame_length[0] = LSB(data);
+		icb->max_frame_length[1] = MSB(data);
 	} else {
 		EL(ha, "invalid parameter value for 'max-frame-length': %d;"
 		    " using nvram default of %d\n", data, CHAR_TO_SHORT(
-		    nv->max_frame_length[0], nv->max_frame_length[1]));
+		    icb->max_frame_length[0], icb->max_frame_length[1]));
 	}
 
 	/* Get execution throttle. */
@@ -1806,12 +1877,12 @@
 		data = 32;
 	}
 	if (data != 0 && data < 65536) {
-		nv->execution_throttle[0] = LSB(data);
-		nv->execution_throttle[1] = MSB(data);
+		icb->execution_throttle[0] = LSB(data);
+		icb->execution_throttle[1] = MSB(data);
 	} else {
 		EL(ha, "invalid parameter value for 'execution-throttle':"
 		    " %d; using nvram default of %d\n", data, CHAR_TO_SHORT(
-		    nv->execution_throttle[0], nv->execution_throttle[1]));
+		    icb->execution_throttle[0], icb->execution_throttle[1]));
 	}
 
 	/* Get Login timeout. */
@@ -1819,12 +1890,12 @@
 		data = 3;
 	}
 	if (data < 65536) {
-		nv->login_timeout[0] = LSB(data);
-		nv->login_timeout[1] = MSB(data);
+		icb->login_timeout[0] = LSB(data);
+		icb->login_timeout[1] = MSB(data);
 	} else {
 		EL(ha, "invalid parameter value for 'login-timeout': %d; "
 		    "using nvram value of %d\n", data, CHAR_TO_SHORT(
-		    nv->login_timeout[0], nv->login_timeout[1]));
+		    icb->login_timeout[0], icb->login_timeout[1]));
 	}
 
 	/* Get retry count. */
@@ -1832,38 +1903,38 @@
 		data = 4;
 	}
 	if (data < 65536) {
-		nv->login_retry_count[0] = LSB(data);
-		nv->login_retry_count[1] = MSB(data);
+		icb->login_retry_count[0] = LSB(data);
+		icb->login_retry_count[1] = MSB(data);
 	} else {
 		EL(ha, "invalid parameter value for 'login-retry-count': "
 		    "%d; using nvram value of %d\n", data, CHAR_TO_SHORT(
-		    nv->login_retry_count[0], nv->login_retry_count[1]));
+		    icb->login_retry_count[0], icb->login_retry_count[1]));
 	}
 
 	/* Get adapter hard loop ID enable. */
-	data =  ql_get_prop(ha, "enable-adapter-hard-loop-ID");
+	data = ql_get_prop(ha, "enable-adapter-hard-loop-ID");
 	if (data == 0) {
-		nv->firmware_options_1[0] =
-		    (uint8_t)(nv->firmware_options_1[0] & ~BIT_0);
+		icb->firmware_options_1[0] =
+		    (uint8_t)(icb->firmware_options_1[0] & ~BIT_0);
 	} else if (data == 1) {
-		nv->firmware_options_1[0] =
-		    (uint8_t)(nv->firmware_options_1[0] | BIT_0);
+		icb->firmware_options_1[0] =
+		    (uint8_t)(icb->firmware_options_1[0] | BIT_0);
 	} else if (data != 0xffffffff) {
 		EL(ha, "invalid parameter value for "
 		    "'enable-adapter-hard-loop-ID': %d; using nvram value "
 		    "of %d\n", data,
-		    nv->firmware_options_1[0] & BIT_0 ? 1 : 0);
+		    icb->firmware_options_1[0] & BIT_0 ? 1 : 0);
 	}
 
 	/* Get adapter hard loop ID. */
-	data =  ql_get_prop(ha, "adapter-hard-loop-ID");
+	data = ql_get_prop(ha, "adapter-hard-loop-ID");
 	if (data < 126) {
-		nv->hard_address[0] = LSB(data);
-		nv->hard_address[1] = MSB(data);
+		icb->hard_address[0] = LSB(data);
+		icb->hard_address[1] = MSB(data);
 	} else if (data != 0xffffffff) {
 		EL(ha, "invalid parameter value for 'adapter-hard-loop-ID':"
 		    " %d; using nvram value of %d\n", data, CHAR_TO_SHORT(
-		    nv->hard_address[0], nv->hard_address[1]));
+		    icb->hard_address[0], icb->hard_address[1]));
 	}
 
 	/* Get LIP reset. */
@@ -1887,13 +1958,14 @@
 		data = 1;
 	}
 	if (data == 0) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] & ~BIT_2);
+		ha->cfg_flags &= ~CFG_ENABLE_FULL_LIP_LOGIN;
 	} else if (data == 1) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] | BIT_2);
+		ha->cfg_flags |= CFG_ENABLE_FULL_LIP_LOGIN;
 	} else {
 		EL(ha, "invalid parameter value for "
 		    "'enable-LIP-full-login-on-bus-reset': %d; using nvram "
-		    "value of %d\n", data, nv->host_p[1] & BIT_2 ? 1 : 0);
+		    "value of %d\n", data,
+		    ha->cfg_flags & CFG_ENABLE_FULL_LIP_LOGIN ? 1 : 0);
 	}
 
 	/* Get target reset. */
@@ -1902,13 +1974,14 @@
 		data = 0;
 	}
 	if (data == 0) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] & ~BIT_3);
+		ha->cfg_flags &= ~CFG_ENABLE_TARGET_RESET;
 	} else if (data == 1) {
-		nv->host_p[1] = (uint8_t)(nv->host_p[1] | BIT_3);
+		ha->cfg_flags |= CFG_ENABLE_TARGET_RESET;
 	} else {
 		EL(ha, "invalid parameter value for "
 		    "'enable-target-reset-on-bus-reset': %d; using nvram "
-		    "value of %d", data, nv->host_p[1] & BIT_3 ? 1 : 0);
+		    "value of %d", data,
+		    ha->cfg_flags & CFG_ENABLE_TARGET_RESET ? 1 : 0);
 	}
 
 	/* Get reset delay. */
@@ -1916,10 +1989,10 @@
 		data = 5;
 	}
 	if (data != 0 && data < 256) {
-		nv->reset_delay = (uint8_t)data;
+		ha->loop_reset_delay = (uint8_t)data;
 	} else {
 		EL(ha, "invalid parameter value for 'reset-delay': %d; "
-		    "using nvram value of %d", data, nv->reset_delay);
+		    "using nvram value of %d", data, ha->loop_reset_delay);
 	}
 
 	/* Get port down retry count. */
@@ -1927,47 +2000,59 @@
 		data = 8;
 	}
 	if (data < 256) {
-		nv->port_down_retry_count[0] = LSB(data);
-		nv->port_down_retry_count[1] = MSB(data);
+		ha->port_down_retry_count = (uint16_t)data;
 	} else {
 		EL(ha, "invalid parameter value for 'port-down-retry-count':"
-		    " %d; using nvram value of %d\n", data, CHAR_TO_SHORT(
-		    nv->port_down_retry_count[0],
-		    nv->port_down_retry_count[1]));
+		    " %d; using nvram value of %d\n", data,
+		    ha->port_down_retry_count);
 	}
 
-	if (!(CFG_IST(ha, CFG_CTRL_8081))) {
+	if (!(CFG_IST(ha, CFG_FCOE_SUPPORT))) {
+		uint32_t	conn;
+
 		/* Get connection mode setting. */
-		if ((data = ql_get_prop(ha, "connection-options")) ==
+		if ((conn = ql_get_prop(ha, "connection-options")) ==
 		    0xffffffff) {
-			data = 2;
+			conn = 2;
 		}
-		if (data <= 2) {
-			nv->firmware_options_2[0] = (uint8_t)
-			    (nv->firmware_options_2[0] &
+		if (conn <= 2) {
+			icb->firmware_options_2[0] = (uint8_t)
+			    (icb->firmware_options_2[0] &
 			    ~(BIT_6 | BIT_5 | BIT_4));
-			nv->firmware_options_2[0] = (uint8_t)
-			    (nv->firmware_options_2[0] | (uint8_t)(data << 4));
+			icb->firmware_options_2[0] = (uint8_t)
+			    (icb->firmware_options_2[0] | (uint8_t)(conn << 4));
 		} else {
 			EL(ha, "invalid parameter value for 'connection-"
-			    "options': %d; using nvram value of %d\n", data,
-			    (nv->firmware_options_2[0] >> 4) & 0x3);
+			    "options': %d; using nvram value of %d\n", conn,
+			    (icb->firmware_options_2[0] >> 4) & 0x3);
 		}
+		conn = icb->firmware_options_2[0] >> 4 & 0x3;
+		if (conn == 0 && ha->max_vports > 125) {
+			ha->max_vports = 125;
+		}
 
 		/* Get data rate setting. */
 		if ((data = ql_get_prop(ha, "fc-data-rate")) == 0xffffffff) {
 			data = 2;
 		}
-		if ((CFG_IST(ha, CFG_CTRL_2422) && data < 4) ||
-		    (CFG_IST(ha, CFG_CTRL_258081) && data < 5)) {
-			nv->firmware_options_3[1] = (uint8_t)
-			    (nv->firmware_options_3[1] & 0x1f);
-			nv->firmware_options_3[1] = (uint8_t)
-			    (nv->firmware_options_3[1] | (uint8_t)(data << 5));
+		if ((CFG_IST(ha, CFG_CTRL_24XX) && data < 4) ||
+		    (CFG_IST(ha, CFG_CTRL_25XX) && data < 5) ||
+		    (CFG_IST(ha, CFG_CTRL_2783) && data < 6)) {
+			if (CFG_IST(ha, CFG_CTRL_2783) && data == 5 &&
+			    conn == 0) {
+				EL(ha, "invalid parameter value for 'fc-data-"
+				    "rate': %d; using nvram value of %d\n",
+				    data, 2);
+				data = 2;
+			}
+			icb->firmware_options_3[1] = (uint8_t)
+			    (icb->firmware_options_3[1] & 0x1f);
+			icb->firmware_options_3[1] = (uint8_t)
+			    (icb->firmware_options_3[1] | (uint8_t)(data << 5));
 		} else {
 			EL(ha, "invalid parameter value for 'fc-data-rate': "
 			    "%d; using nvram value of %d\n", data,
-			    (nv->firmware_options_3[1] >> 5) & 0x7);
+			    (icb->firmware_options_3[1] >> 5) & 0x7);
 		}
 	}
 
@@ -2016,7 +2101,7 @@
 
 	ADAPTER_STATE_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -2042,7 +2127,7 @@
 	/*
 	 * Look for a adapter instance NPIV (virtual port) specific parameter
 	 */
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		(void) sprintf(buf, "hba%d-vp%d-%s", ha->instance,
 		    ha->vp_index, string);
 		/*LINTED [Solaris DDI_DEV_T_ANY Lint warning]*/
@@ -2095,16 +2180,27 @@
 	caddr_t		bufp;
 	uint16_t	risc_address = (uint16_t)ha->risc_fw[0].addr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Test for firmware running. */
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
-		if (ql_8021_idc_handler(ha) != NX_DEV_READY) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		if ((rval = ql_8021_fw_chk(ha)) == QL_SUCCESS) {
+			rval = ql_start_firmware(ha);
+		}
+	} else if (CFG_IST(ha, CFG_CTRL_278083)) {
+		ha->dev_state = NX_DEV_READY;
+		if (ha->rom_status == MBS_ROM_FW_RUNNING) {
+			EL(ha, "ISP ROM Status = MBS_ROM_FW_RUNNING\n");
+			rval = QL_SUCCESS;
+		} else if (ha->rom_status == MBS_ROM_IDLE) {
+			EL(ha, "ISP ROM Status = MBS_ROM_IDLE\n");
 			rval = QL_FUNCTION_FAILED;
 		} else {
-			rval = ql_start_firmware(ha);
+			EL(ha, "ISP ROM Status, mbx0=%xh\n", ha->rom_status);
+			rval = QL_FUNCTION_FAILED;
 		}
 	} else if (CFG_IST(ha, CFG_DISABLE_RISC_CODE_LOAD)) {
+		ha->dev_state = NX_DEV_READY;
 		if (ha->risc_code != NULL) {
 			kmem_free(ha->risc_code, ha->risc_code_size);
 			ha->risc_code = NULL;
@@ -2112,10 +2208,10 @@
 		}
 
 		/* Get RISC code length. */
-		rval = ql_rd_risc_ram(ha, risc_address + 3, ha->request_dvma,
-		    1);
+		rval = ql_rd_risc_ram(ha, risc_address + 3,
+		    ha->req_q[0]->req_ring.cookie.dmac_laddress, 1);
 		if (rval == QL_SUCCESS) {
-			lptr = (uint32_t *)ha->request_ring_bp;
+			lptr = (uint32_t *)ha->req_q[0]->req_ring.bp;
 			fw_size = *lptr << 1;
 
 			if ((bufp = kmem_alloc(fw_size, KM_SLEEP)) != NULL) {
@@ -2136,7 +2232,8 @@
 					    (uint16_t)(byte_count >> 1);
 
 					rval = ql_rd_risc_ram(ha, risc_address,
-					    ha->request_dvma, word_count);
+					    ha->req_q[0]->req_ring.cookie.
+					    dmac_laddress, word_count);
 					if (rval != QL_SUCCESS) {
 						kmem_free(ha->risc_code,
 						    ha->risc_code_size);
@@ -2146,13 +2243,13 @@
 					}
 
 					(void) ddi_dma_sync(
-					    ha->hba_buf.dma_handle,
-					    REQUEST_Q_BUFFER_OFFSET,
-					    byte_count,
+					    ha->req_q[0]->req_ring.dma_handle,
+					    0, byte_count,
 					    DDI_DMA_SYNC_FORKERNEL);
-					ddi_rep_get16(ha->hba_buf.acc_handle,
-					    (uint16_t *)bufp,
-					    (uint16_t *)ha->request_ring_bp,
+					ddi_rep_get16(
+					    ha->req_q[0]->req_ring.acc_handle,
+					    (uint16_t *)bufp, (uint16_t *)
+					    ha->req_q[0]->req_ring.bp,
 					    word_count, DDI_DEV_AUTOINCR);
 
 					risc_address += word_count;
@@ -2163,6 +2260,7 @@
 			rval = QL_FUNCTION_FAILED;
 		}
 	} else {
+		ha->dev_state = NX_DEV_READY;
 		rval = QL_FUNCTION_FAILED;
 	}
 
